

   comment*
   -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

      Edit control using a Modeless dialog box created from an
      in-Memory dialog box template.

   -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= *


    .586                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\msvcrt.lib

    DlgBox PROTO :DWORD, :DWORD, :DWORD, :DWORD

    .const
;      IDCANCEL equ   0        


    .data?


    .data
        hInstance         dd     0
        hdlg              dd     0
        dlgtemplatebuff   dd    1024 dup(0)        ; dlg template buffer - needs to be dword aligned
        editcontrol_buff  db    1024 dup(0)  
        ret_val           dd     0
        error_code        dd     0        

        dlgboxtitle       db    "Dialog Foundary - ",0
        button_title      db    "OK",0
        editbox_title     db   "edit_control",0
        
        font_name         db    "fixedsys",0

align 4
        msg             MSG     <0>



        
; -----------------------------------------------------------------------


    .code

start:

        mov hInstance, FUNC(GetModuleHandle,NULL)

        call create_dialog

        fn MessageBox, NULL, "T E S T", "Text Entered", MB_OK

;       fn MessageBox, NULL, addr editcontrol_buff, "Text Entered", MB_OK
        
        invoke ExitProcess, eax  


; ----------------------------------------------------
;          Fill in the dialog box template
; ----------------------------------------------------

  create_dialog:

    mov edi, offset dlgtemplatebuff            ; should be DWORD aligned

                                               ; style
    mov dword ptr [edi+0],   WS_POPUP or WS_SYSMENU or WS_CAPTION or WS_VISIBLE or WS_BORDER or DS_SETFONT
    mov dword ptr [edi+4],      0              ; extended styles
    mov  word ptr [edi+8],      2              ; control item-count
    mov  word ptr [edi+10],     100            ; x co-ordinate
    mov  word ptr [edi+12],     100            ; y co-ordinate
    mov  word ptr [edi+14],     100            ; width
    mov  word ptr [edi+16],     45             ; height
    
 ;    18 bytes used till here   

    mov  word ptr [edi+18],      0             ; Menu array   (0 = no menu)
    mov  word ptr [edi+20],      0             ; Class array  (0 = predifined dialogbox class)


 ;  *Title* - 22 bytes used till here 

    add edi,  22                               ; Title array start address

    invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr dlgboxtitle, -1,
                                edi, LENGTHOF dlgboxtitle
    add edi, LENGTHOF dlgboxtitle*2


 ; ========== * Font * =========================

    mov word ptr [edi],          9             ; point size value of the font
    add edi,  2
    

 ; -- [ Font name, conerted into a unicode string ] ---------

    invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr font_name, -1,
                                edi, LENGTHOF font_name

    add edi, LENGTHOF font_name*2

   
 ; --------------------------------------------------------------------------------------
 ;       Fill in the dialog box items template - Button Control - (DlgItemTemplate)
 ; --------------------------------------------------------------------------------------



       memalign edi, 4
       mov dword ptr [edi+0] ,   BS_DEFPUSHBUTTON or WS_CHILD or WS_VISIBLE     ; style
       mov dword ptr [edi+4] ,   0           ;  extended style
       mov  word ptr [edi+8] ,   32          ;  x-coordinate
       mov  word ptr [edi+10],   25          ;  y-coordinate
       mov  word ptr [edi+12],   30          ;  width , in dialog box units, of the control
       mov  word ptr [edi+14],   15          ;  height, in dialog box units, of the control
       mov  word ptr [edi+16],   IDCANCEL    ;  control identifier

       mov word ptr [edi+18], 65535         
       mov word ptr [edi+20], 128            ; signifies a 'buttonclass' for the control


  ; ====== Title array ==============

       add edi, 22

       invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr button_title, -1,
                                   edi, LENGTHOF button_title
       add edi, LENGTHOF button_title*2

       memalign edi, 4
       mov word ptr [edi],  0                ;  creation data
       add edi           ,  2


  ; ================================
  ;       Edit Control
  ; ================================

       memalign edi, 4
       mov dword ptr [edi+0] ,   ES_LEFT or ES_AUTOHSCROLL or WS_CHILD or WS_VISIBLE    ; style
       mov dword ptr [edi+4] ,   0           ;  extended style
       mov  word ptr [edi+8] ,   20          ;  x-coordinate
       mov  word ptr [edi+10],   10          ;  y-coordinate
       mov  word ptr [edi+12],   50          ;  width , in dialog box units, of the control
       mov  word ptr [edi+14],   10          ;  height, in dialog box units, of the control
       mov  word ptr [edi+16],   100         ;  control identifier (255 max)

       mov word ptr [edi+18], 65535         
       mov word ptr [edi+20], 129            ; signifies a 'EDIT' class for the control

; ============ title array ===================

       add edi, 22
       invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr editbox_title, -1,
                                   edi, LENGTHOF editbox_title*2
       add edi, LENGTHOF editbox_title*2


;      creation data
; ============================================
;      memalign edi, 4
       mov dword ptr [edi],  0                ;  creation data
       add edi           ,   4

; =====================x====== - End of Template - ======x================================
       

       
    invoke CreateDialogIndirectParam, hInstance, addr dlgtemplatebuff, 0,  DlgBox, 0
    mov hdlg, eax                         ; handle to the dialog


    Messageloop:

      invoke GetMessage, addr msg, hdlg, 0, 0
      mov ret_val, eax

        .if ret_val == SDWORD PTR -1  
            fn MessageBox,0,"error","Title",MB_OK
            jmp ExitMsgLoop
  
        .elseif ret_val == 0
            jmp ExitMsgLoop
  
        .else
            invoke IsDialogMessage, hdlg, addr msg
        .endif

        jmp Messageloop

    ExitMsgLoop:
          mov eax, msg.wParam
          ret

; = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 

    DlgBox proc hWndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
  

           .if uMsg == WM_COMMAND                    ; lParam = handle of control
               movzx ecx, word ptr [wParam]          ; low word of wParam - control identifier
               movzx ebx, word ptr [wParam+2]        ; high word of wParam - notification msg

               .if ecx == IDCANCEL
                   invoke GetDlgItemText, hWndDlg, 100, addr editcontrol_buff, 1000
                   jmp end_dialog
               .endif

               jmp true_                             ; true = proc processed the msg                    

;     -----------------------------------------------
;        carry out initialization tasks here
;     -----------------------------------------------

           .elseif uMsg == WM_INITDIALOG             
               jmp true_                             ; direct the system to process the msg

           .elseif uMsg == WM_DESTROY   
               fn MessageBox, NULL, addr editcontrol_buff, "Text Entered", MB_OK
               invoke PostQuitMessage, NULL
               jmp true_

;            .elseif uMsg == WM_CLOSE
;               jmp end_dialog   

           .else
               jmp false_                            ; default processing
                               
           .endif    


        end_dialog:
          
          invoke DestroyWindow, hWndDlg
    
        true_:                                    ; dlg proc processed the msg TRUE
           mov eax, 1                             ; return true (for processing a msg)
           jmp ret_
                          
        false_:                                   ; to direct the system to process the msg
           xor eax, eax                           ; return false (proc didn't process the msg)
            
    
        ret_:    
          ret
      
    DlgBox endp



end start










